local blank = "Interface\\AddOns\\ncMedia\\blank"
local blank2 = "Interface\\AddOns\\ncMedia\\blank2"
local g = CreateFrame("Frame", "BagBackgroundAnchor")
CreatePanel(g, 20, 50, "CENTER", UIParent, "CENTER", 0, 400)
g:EnableMouse(true)
g:SetMovable(true)
g:SetUserPlaced(true)
g:RegisterForDrag("LeftButton")
g:SetScript("OnDragStart", g.StartMoving)
g:SetScript("OnDragStop", g.StopMovingOrSizing)
g:SetScale(.64)
g:Hide()

g.text = g:CreateFontString(nil, "OVERLAY")
g.text:SetFont("Interface\\AddOns\\ncMedia\\slkscr.TTF", 12, "MONOCHROME")
g.text:SetPoint("CENTER", g)
g.text:SetText("BAGS")

local f = CreateFrame("Frame", "BagBackgroundFrame", BagBackgroundAnchor)
CreatePanel(f, 0, 480, "TOPLEFT", BagBackgroundAnchor, "BOTTOMLEFT", 0, -5)
f:SetFrameStrata("DIALOG")

local h = CreateFrame("Frame", "BagClosebutton", BagBackgroundAnchor)
CreatePanel(h, 20, 20, "BOTTOMRIGHT", f, "TOPRIGHT", 0, 5)
h:EnableMouse(true)
h:SetScript("OnMouseup", CloseAllBags)
h.x = g:CreateFontString(nil, "OVERLAY")
h.x:SetFont("Interface\\AddOns\\ncMedia\\slkscr.TTF", 12, "MONOCHROME")
h.x:SetPoint("CENTER", h, "CENTER", -1, 1)
h.x:SetText("X")

local i = CreateFrame("Frame", "BagMoneyBackground", BagBackgroundAnchor)
i:EnableMouse(true)
i.moneyType = "PLAYER"
i:SetScript("OnMouseup", function() OpenCoinPickupFrame(COPPER_PER_GOLD, MoneyTypeInfo["PLAYER"].UpdateFunc(), i) end)
i.x = i:CreateFontString(nil, "OVERLAY")
i.x:SetFont("Interface\\AddOns\\ncMedia\\slkscr.TTF", 12, "MONOCHROME")
i.x:SetPoint("CENTER", i, "CENTER", -1, 1)
local co = GetMoney()
local go, si, co = tonumber(string.sub(co,1,-5)) or 0, tonumber(string.sub(co,-4,-3)) or 0, tonumber(string.sub(co,-2,-1)) or 0
i.x:SetText("|cFF999999"..go.."|cffffd700g|cFF999999 "..si.."|cffc7c7cfs|cFF999999 "..co.."|cffeda55fc")
CreatePanel(i, 20, i.x:GetStringWidth()+10, "BOTTOM", f, "TOP", 0, 5)

ContainerFrame5:HookScript("OnShow", function()
	local numrows, lastrowbutton, numbuttons, lastbutton = 0, ContainerFrame1Item1, 1, ContainerFrame1Item1
	for i=1,5 do
		for j=1,GetContainerNumSlots(i-1) do
			local b = _G["ContainerFrame"..i.."Item"..j]
			b:ClearAllPoints()
			if j==1 and i==1 then
				b:SetPoint("TOPLEFT", BagBackgroundFrame, "TOPLEFT", 10, -10)
			elseif numbuttons/10==floor(numbuttons/10) then
				b:SetPoint("TOP", lastrowbutton, "BOTTOM", 0, -10)
				lastrowbutton = _G["ContainerFrame"..i.."Item"..j]
				numrows = numrows+1
				numbuttons = numbuttons + 1
			else
				b:SetPoint("LEFT", lastbutton, "RIGHT", 10, 0)
				numbuttons = numbuttons + 1
			end
			if not _G[b:GetName().."Panel"] then
				local p = CreateFrame("Frame", b:GetName().."Panel", b)
				p:SetFrameStrata("DIALOG")
				p:SetWidth(b:GetWidth()+4)
				p:SetHeight(b:GetHeight()+4)
				p:SetPoint("TOPLEFT", b, "TOPLEFT", -2, 2)
				p:SetBackdrop({ 
					bgFile = blank2, 
					edgeFile = blank, 
					tile = false, tileSize = 0, edgeSize = 1, 
					insets = { left = -1, right = -1, top = -1, bottom = -1 }
				})
				p:SetBackdropColor(.1,.1,.1)
				p:SetBackdropBorderColor(.6,.6,.6)
				_G[b:GetName().."IconTexture"]:SetTexCoord(0.1,0.9,0.1,0.9)
				b:SetNormalTexture(blank2)
				b:SetPushedTexture(blank2)
				b:SetHighlightTexture(blank2)					
				b:HookScript("OnEnter", function() _G[b:GetName().."Panel"]:SetBackdropBorderColor(.8,.8,.8) end)
				b:HookScript("OnLeave", function() _G[b:GetName().."Panel"]:SetBackdropBorderColor(.6,.6,.6) end)
				b:HookScript("OnMouseDown", function() _G[b:GetName().."Panel"]:SetBackdropBorderColor(1,1,1) end)
				b:HookScript("OnMouseUp", function() _G[b:GetName().."Panel"]:SetBackdropBorderColor(.6,.6,.6) end)
				local count = _G[b:GetName().."Count"]
				count:ClearAllPoints()
				count:SetPoint("BOTTOMRIGHT", 0, 2)
				count:SetFont("Interface\\Addons\\ncMedia\\slkscr.ttf", 11, "MONOCHROME, THINOUTLINE")
			end
			b:SetFrameStrata("DIALOG")
			lastbutton = b
		end
	end
	f:SetHeight(47*(numrows+1)+10)
	g:Show()
end)

hooksecurefunc("ContainerFrame_OnHide", function() g:Hide() end)

ToggleBag = function()
	if ( IsOptionFrameOpen() ) then
		return
	end
	for id=0,NUM_CONTAINER_FRAMES do
		if not GetBagName(id) then return end
		local size = GetContainerNumSlots(id)
		if ( size > 0 or id == KEYRING_CONTAINER ) then
			local containerShowing
			for i=1, NUM_CONTAINER_FRAMES, 1 do
				local frame = _G["ContainerFrame"..i]
				if ( frame:IsShown() and frame:GetID() == id ) then
					containerShowing = i
					frame:Hide()
				end
			end
			if ( not containerShowing ) then
				ContainerFrame_GenerateFrame(ContainerFrame_GetOpenFrame(), size, id)
			end
		end
		_G["ContainerFrame"..(id+1).."PortraitButton"]:Hide()
		_G["ContainerFrame"..(id+1).."CloseButton"]:Hide()
		_G["ContainerFrame"..(id+1)]:EnableMouse(false)
		_G["ContainerFrame"..(id+1)]:SetPoint("TOPLEFT", UIParent, "BOTTOMRIGHT", 1000, -1000)
	end
end